import{csv, json} from 'd3';
import { feature } from 'topojson';



export const loadAndProcessData = () => 
  Promise
    .all([
      csv('https://vizhub.com/jons288/datasets/avocado_2017_latest.csv'),
      json('https://gist.githubusercontent.com/mbostock/4090846/raw/d534aba169207548a8a3d670c9c2cc719ff05c47/us.json')
    ])
    .then(([csvData, topoJSONdata]) => {
     
      const daySales = csvData.filter(d => d.Date ==="1/15/2017")
      
      const rowById = daySales.reduce((accumulator, d) => {
        accumulator[d['id']] = d;
        return accumulator;
        
      }, {});
       
      const states = feature(topoJSONdata, topoJSONdata.objects.states);
    
      states.features.forEach(d => { 
        Object.assign(d.properties,rowById[d.id]);
      });
      
      return states;   
      
    });   